/*FileName: WCRffsx_fnc_Suicide.sqf
  Author: WCR
  Effects: This is the script which can exert body suicide bomb or vehicle suicide bomb effect.
  Usage: WCRSuicide = [Suicider,Victim,Attacking range (must be more than 35m)] execVM "WCRffsx_fnc_Suicide.sqf"
  Creating Date: 9Jan 2011
  Version 1.46
  Current Updating Date: 28April 2011

  Changelog:
  v1.46
  Added: Secondary explosion of vehicle suicide assault
  v1.45
  Suicider bomber may carry different bombs to assault
  Suicider bomber will no longer fleeing or refuse moving during an attack
  v1.44
  Fixed: Script structure error
*/
private ["_WCRffsx_bomber","_WCRffsx_Victim","_WCRffsx_VictimGroup","_WCRffsx_Arrary","_WCRffsx_Num","_WCRffsx_bomberGroup","_WCRffsx_ArraryB","_WCRffsx_NumB","_WCRffsx_Meters","_gp","_bombs","_bombNum","_possibility"];
_bombs = ["ARTY_Sh_105_HE","R_Hydra_HE","ARTY_Sh_122_HE","ARTY_Sh_81_HE","ARTY_Sh_82_HE"];
_bombNum = count _bombs;
_WCRffsx_bomber = _this select 0;
_WCRffsx_Victim = _this select 1;
_WCRffsx_VictimGroup = group _WCRffsx_Victim;
_WCRffsx_Arrary = units _WCRffsx_VictimGroup;
_WCRffsx_Num = count _WCRffsx_Arrary;
_WCRffsx_bomberGroup = group _WCRffsx_bomber;
_WCRffsx_ArraryB = units _WCRffsx_bomberGroup;
_WCRffsx_NumB = count _WCRffsx_ArraryB;
_WCRffsx_Meters = _this select 2;
if ((isNull _WCRffsx_bomber) || (isNull _WCRffsx_Victim)) exitWith {
     hintSilent "If this script can not run properly in MP, please check whether you have disabled AI";
     };
if (_WCRffsx_Meters<=35) exitWith {
     hintSilent "You've activated Vehicle Suicide Bombing mod, Suicide vehicle will attack only Land vehicle and infantry target but not Air or ship targets etc.If you can not run this script in MP, please check whether you've disabled AI. Be notice that never group the suicider into team at anytime when this script is running.";
};
//Vehicle Assault
if ((alive _WCRffsx_Victim) && (canMove vehicle _WCRffsx_bomber) && ((vehicle _WCRffsx_bomber) isKindOf "Car") && (alive _WCRffsx_bomber) && (_WCRffsx_NumB==1) && (_WCRffsx_Meters>35)) then {
     if ((((Vehicle _WCRffsx_Victim) isKindOf "LandVehicle")||((Vehicle _WCRffsx_Victim) isKindOf "Man"))) then {
         switch (side (vehicle _WCRffsx_Victim)) do {
             case (west):
             {
                 _gp = createGroup west;
                 [_WCRffsx_bomber] joinSilent _gp;
                 (vehicle _WCRffsx_bomber) setcaptive true;
             };
             case (east):
             {
                 _gp = createGroup east;
                 [_WCRffsx_bomber] joinSilent _gp;
                 (vehicle _WCRffsx_bomber) setcaptive true;
             };
             case (civilian):
             {
                 _gp = createGroup civilian;
                 [_WCRffsx_bomber] joinSilent _gp;
                 (vehicle _WCRffsx_bomber) setcaptive true;
             };
             case (resistance):
             {
                 _gp = createGroup resistance;
                 [_WCRffsx_bomber] joinSilent _gp;
                 (vehicle _WCRffsx_bomber) setcaptive true;
             };
         };
               (vehicle _WCRffsx_bomber) disableAI "AUTOTARGET";
               (vehicle _WCRffsx_bomber) disableAI "TARGET"; 
               (vehicle _WCRffsx_bomber) setCombatMode "BLUE";
               RemoveAllWeapons _WCRffsx_bomber;
               (vehicle _WCRffsx_bomber) setbehaviour "CARELESS";
               (vehicle _WCRffsx_bomber) addBackPack "TK_ALICE_Pack_EP1"; 
         while {((vehicle _WCRffsx_bomber) distance _WCRffsx_Victim) <= _WCRffsx_Meters} do {
             sleep 5; //5 is the minimal looping time for vehicle moving, it won't move and will only stop at its origional position if you adjust it too small
             (vehicle _WCRffsx_bomber) move (position _WCRffsx_Victim);
             if (((vehicle _WCRffsx_bomber) distance _WCRffsx_Victim) <= 35) exitWith {
                 (vehicle _WCRffsx_bomber) addRating -5000;
                 (vehicle _WCRffsx_bomber) setcaptive false;
                 IED="Bo_Mk82" createVehicle getpos (vehicle _WCRffsx_bomber);
                 _possibility = ceil (random 100);
                 if (_possibility > 90) then {
                     IED=(_bombs select ((ceil (random _bombNum)) - 1)) createVehicle getpos (vehicle _WCRffsx_bomber);
                 } else {
                 };
             };
         };
         if (true) exitWith {
         };
     } else {
     };
     } else {
     };
                  //Group Assault
         if ((alive Leader _WCRffsx_VictimGroup)&&(alive _WCRffsx_bomber)&&(vehicle (Leader _WCRffsx_VictimGroup)==Leader _WCRffsx_VictimGroup)&&(vehicle _WCRffsx_bomber==_WCRffsx_bomber)&&(_WCRffsx_Num>5)&&(canStand _WCRffsx_bomber)) then {
             switch (side (vehicle _WCRffsx_Victim)) do {
             case (west):
             {
                 _gp = createGroup west;
                 [_WCRffsx_bomber] joinSilent _gp;
                 (vehicle _WCRffsx_bomber) setcaptive true;
             };
             case (east):
             {
                 _gp = createGroup east;
                 [_WCRffsx_bomber] joinSilent _gp;
                 (vehicle _WCRffsx_bomber) setcaptive true;
             };
             case (civilian):
             {
                 _gp = createGroup civilian;
                 [_WCRffsx_bomber] joinSilent _gp;
                 (vehicle _WCRffsx_bomber) setcaptive true;
             };
             case (resistance):
             {
                 _gp = createGroup resistance;
                 [_WCRffsx_bomber] joinSilent _gp;
                 (vehicle _WCRffsx_bomber) setcaptive true;
             };
         };
                   _WCRffsx_bomber disableAI "AUTOTARGET";
                   _WCRffsx_bomber disableAI "TARGET"; 
                   removeallweapons _WCRffsx_bomber;
                   _WCRffsx_bomber setbehaviour "CARELESS";
                   _WCRffsx_bomber addBackPack "TK_ALICE_Pack_EP1";
                   sleep 1;
             while {_WCRffsx_bomber distance (Leader _WCRffsx_VictimGroup) <= _WCRffsx_Meters} do {
                 sleep 1;
                 _WCRffsx_bomber move getpos (Leader _WCRffsx_VictimGroup);
                 if (_WCRffsx_bomber distance (Leader _WCRffsx_VictimGroup) <=35) then {
                     _WCRffsx_bomber addRating -5000;
                     (vehicle _WCRffsx_bomber) setcaptive false;
                     if (!canStand _WCRffsx_bomber) exitWith {
                         IED=(_bombs select ((ceil (random _bombNum)) - 1)) createVehicle getpos _WCRffsx_bomber;
                         deleteVehicle _WCRffsx_bomber;
                     };
                     if ((_WCRffsx_bomber distance (Leader _WCRffsx_VictimGroup) <=7.5)) then {
                         IED=(_bombs select ((ceil (random _bombNum)) - 1)) createVehicle getpos _WCRffsx_bomber;
                         deleteVehicle _WCRffsx_bomber;
                     } else {
                     };
                 } else {
                 };
             };
             if (true) exitWith {
             };
               } else {
               };
     //Single Assault
     if ((alive _WCRffsx_Victim)&&(alive _WCRffsx_bomber)&&(vehicle _WCRffsx_Victim==_WCRffsx_Victim)&&(vehicle _WCRffsx_bomber==_WCRffsx_bomber)&&(_WCRffsx_NumB==1)) then {         
         switch (side (vehicle _WCRffsx_Victim)) do {
             case (west):
             {
                 _gp = createGroup west;
                 [_WCRffsx_bomber] joinSilent _gp;
                 _WCRffsx_bomber setcaptive true;
             };
             case (east):
             {
                 _gp = createGroup east;
                 [_WCRffsx_bomber] joinSilent _gp;
                 _WCRffsx_bomber setcaptive true;
             };
             case (civilian):
             {
                 _gp = createGroup civilian;
                 [_WCRffsx_bomber] joinSilent _gp;
                 _WCRffsx_bomber setcaptive true;
             };
             case (resistance):
             {
                 _gp = createGroup resistance;
                 [_WCRffsx_bomber] joinSilent _gp;
                 _WCRffsx_bomber setcaptive true;
             };
         };
         _WCRffsx_bomber disableAI "AUTOTARGET";
         _WCRffsx_bomber disableAI "TARGET"; 
         _WCRffsx_bomber allowFleeing 0;
         removeallweapons _WCRffsx_bomber;
         _WCRffsx_bomber setbehaviour "CARELESS";
         _WCRffsx_bomber addBackPack "TK_ALICE_Pack_EP1";
         sleep 1;
         while {_WCRffsx_bomber distance _WCRffsx_Victim <= _WCRffsx_Meters} do {
             sleep 1;
             _WCRffsx_bomber move getpos _WCRffsx_Victim;
             if (_WCRffsx_bomber distance _WCRffsx_Victim <=35) then {
                 _WCRffsx_bomber setcaptive false;
                 _WCRffsx_bomber addRating -5000;
                 (vehicle _WCRffsx_bomber) setcaptive false;
                 if (!canStand _WCRffsx_bomber) then {
                     IED=(_bombs select ((ceil (random _bombNum)) - 1)) createVehicle getpos _WCRffsx_bomber;
                     deleteVehicle _WCRffsx_bomber;
                 } else {
                 };
             } else {
             };
             if (_WCRffsx_bomber distance _WCRffsx_Victim <=7.5) exitWith {
                 IED=(_bombs select ((ceil (random _bombNum)) - 1)) createVehicle getpos _WCRffsx_bomber;
                 deleteVehicle _WCRffsx_bomber;
             };
         };
         if (true) exitWith {
         };
     } else {
     };
     //MotorCycle Assault
if ((alive _WCRffsx_Victim) && (canMove vehicle _WCRffsx_bomber) && ((vehicle _WCRffsx_bomber) isKindOf "MotorCycle") && (alive _WCRffsx_bomber) && (_WCRffsx_NumB==1) && (_WCRffsx_Meters>35)) then {
     if ((((Vehicle _WCRffsx_Victim) isKindOf "LandVehicle")||((Vehicle _WCRffsx_Victim) isKindOf "Man"))) then {
         switch (side (vehicle _WCRffsx_Victim)) do {
             case (west):
             {
                 _gp = createGroup west;
                 [_WCRffsx_bomber] joinSilent _gp;
                 (vehicle _WCRffsx_bomber) setcaptive true;
             };
             case (east):
             {
                 _gp = createGroup east;
                 [_WCRffsx_bomber] joinSilent _gp;
                 (vehicle _WCRffsx_bomber) setcaptive true;
             };
             case (civilian):
             {
                 _gp = createGroup civilian;
                 [_WCRffsx_bomber] joinSilent _gp;
                 (vehicle _WCRffsx_bomber) setcaptive true;
             };
             case (resistance):
             {
                 _gp = createGroup resistance;
                 [_WCRffsx_bomber] joinSilent _gp;
                 (vehicle _WCRffsx_bomber) setcaptive true;
             };
         };
               (vehicle _WCRffsx_bomber) disableAI "AUTOTARGET";
               (vehicle _WCRffsx_bomber) disableAI "TARGET"; 
               (vehicle _WCRffsx_bomber) setCombatMode "BLUE";
               RemoveAllWeapons (vehicle _WCRffsx_bomber);
               (vehicle _WCRffsx_bomber) setbehaviour "CARELESS";
               (vehicle _WCRffsx_bomber) addBackPack "TK_ALICE_Pack_EP1"; 
         while {((vehicle _WCRffsx_bomber) distance (vehicle _WCRffsx_Victim)) <= _WCRffsx_Meters} do {
             sleep 5; //5 is the minimal looping time for vehicle moving, it won't move and will only stop at its origional position if you adjust it too small
             (vehicle _WCRffsx_bomber) move (position (vehicle _WCRffsx_Victim));
             if (((vehicle _WCRffsx_bomber) distance (vehicle _WCRffsx_Victim)) <= 35) then {
                 (vehicle _WCRffsx_bomber) addRating -5000;
                 (vehicle _WCRffsx_bomber) setcaptive false;
                 if (((vehicle _WCRffsx_bomber) distance (vehicle _WCRffsx_Victim)) <= 7.5) exitWith {
                     IED=(_bombs select ((ceil (random _bombNum)) - 1)) createVehicle getpos (vehicle _WCRffsx_bomber);
                 };             
                 if (damage (vehicle _WCRffsx_bomber) >= 0.1) exitWith {
                     IED=(_bombs select ((ceil (random _bombNum)) - 1)) createVehicle getpos (vehicle _WCRffsx_bomber);
                 };
             } else {
             };
         };
         if (true) exitWith {
         };
     } else {
     };
     } else {
     };
     //MotorCycle Group Assault
     if ((alive _WCRffsx_Victim) && (canMove vehicle _WCRffsx_bomber) && ((vehicle _WCRffsx_bomber) isKindOf "MotorCycle") && (alive _WCRffsx_bomber) && (_WCRffsx_NumB==1) && (_WCRffsx_Meters>35)&&(_WCRffsx_Num>5)) then {
         if ((((Vehicle _WCRffsx_Victim) isKindOf "LandVehicle")||((Vehicle (Leader _WCRffsx_VictimGroup)) isKindOf "Man"))) then {
             switch (side (vehicle _WCRffsx_Victim)) do {
             case (west):
             {
                 _gp = createGroup west;
                 [_WCRffsx_bomber] joinSilent _gp;
                 (vehicle _WCRffsx_bomber) setcaptive true;
             };
             case (east):
             {
                 _gp = createGroup east;
                 [_WCRffsx_bomber] joinSilent _gp;
                 (vehicle _WCRffsx_bomber) setcaptive true;
             };
             case (civilian):
             {
                 _gp = createGroup civilian;
                 [_WCRffsx_bomber] joinSilent _gp;
                 (vehicle _WCRffsx_bomber) setcaptive true;
             };
             case (resistance):
             {
                 _gp = createGroup resistance;
                 [_WCRffsx_bomber] joinSilent _gp;
                 (vehicle _WCRffsx_bomber) setcaptive true;
             };
         };
               (vehicle _WCRffsx_bomber) disableAI "AUTOTARGET";
               (vehicle _WCRffsx_bomber) disableAI "TARGET"; 
               (vehicle _WCRffsx_bomber) setCombatMode "BLUE";
               RemoveAllWeapons (vehicle _WCRffsx_bomber);
               (vehicle _WCRffsx_bomber) setbehaviour "CARELESS";
               (vehicle _WCRffsx_bomber) addBackPack "TK_ALICE_Pack_EP1"; 
             while {((vehicle _WCRffsx_bomber) distance (Leader _WCRffsx_VictimGroup)) <= _WCRffsx_Meters} do {
             sleep 5; //5 is the minimal looping time for vehicle moving, it won't move and will only stop at its origional position if you adjust it too small
                 (vehicle _WCRffsx_bomber) move (position (Leader _WCRffsx_VictimGroup));
                 if (((vehicle _WCRffsx_bomber) distance (Leader _WCRffsx_VictimGroup)) <= 35) then {
                 (vehicle _WCRffsx_bomber) addRating -5000;
                     (vehicle _WCRffsx_bomber) setcaptive false;
                     if (((vehicle _WCRffsx_bomber) distance (Leader _WCRffsx_VictimGroup)) <= 7.5) then {
                     IED=(_bombs select ((ceil (random _bombNum)) - 1)) createVehicle getpos _WCRffsx_bomber;
                 } else {
                 };
                 if (damage (vehicle _WCRffsx_bomber) >= 0.1) exitWith {
                     IED=(_bombs select ((ceil (random _bombNum)) - 1)) createVehicle getpos (vehicle _WCRffsx_bomber);
                 };
             } else {
             };
         };
         if (true) exitWith {
         };
     } else {
     };
     } else {
     }